/* 
 * tclCmdFont.c --
 *
 *	This file not contains the top-level command routines for most of
 *	the Tcl built-in commands whose names begin with the letters
 *	A to H.
 *
 * Copyright (c) 1987-1993 The Regents of the University of California.
 * Copyright (c) 1994-1995 Sun Microsystems, Inc.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

static char sccsid[] = "@(#) tkCmdFont.c 1.100 95/12/29 11:13:10";

#include "tkInt.h"
#include "tkPort.h"

#include "tcl.h"
/*#include "tclInt.h" */
#include <ctype.h>
#include <string.h>



typedef struct {
        int     encoding;
        int     dwidth;
        int     bbxw,bbxh,bbxxoff,bbxyoff;
        char    *bitmap;
} BdfFont;

typedef struct {
        char *name;
        Tcl_HashTable *Bdftable;
} BdfFontIndex;




 /*----------------------------------------------------------------------
 *
 * Tk_CmdDestroy --
 *
 *	This procedure is invoked to process the "destroyfont" Tk command.
 *	See the user documentation for details on what it does.
 *
 * Results:
 *	A standard Tk result.
 *
 * Side effects:
 *	See the user documentation.
 *
 *----------------------------------------------------------------------
 */

int
Tk_DestroyFontCmd(dummy, interp, argc, argv)
    ClientData dummy;			/* Not used. */
    Tcl_Interp *interp;			/* Current interpreter. */
    int argc;				/* Number of arguments. */
    char **argv;			/* Argument strings. */

{
	int x;
	Tcl_HashEntry *entryPtrIndex;
	Tcl_HashEntry *entryPtr;
	char *aux;
	int loloargc;
	char loloargv[10][20], *item;
	char dir[200];
	extern  Tcl_HashTable *Bdftable;
	extern  Tcl_HashTable *BdftableIndex;
	extern  int	primero;
 	BdfFont *kk;
 	BdfFontIndex *kkIndex;
	char *aux2;
	Tcl_HashSearch search;



	strcpy(dir,"TK_LIBRARY");
	strcat(dir,"/font");	
	if ((argc<2)||(argc>3)){
                    Tcl_AppendResult(interp, "bad number of arguments, ",
                                "destroyfont font_name \"",
			(char *) NULL);
		return TCL_ERROR;
	}

        if (primero>0){
		aux2=Tcl_GetVar(interp,"FONT_LIST",TCL_GLOBAL_ONLY|TCL_LEAVE_ERR_MSG);
        	if((primero>0)&&((char *)strstr(aux2,argv[1])!=NULL)){
			aux2=Tcl_GetVar2(interp,"MISFONTS",argv[1],TCL_GLOBAL_ONLY);
                	entryPtrIndex=Tcl_FindHashEntry(BdftableIndex,aux2);
		}
		else entryPtrIndex=NULL;
        }
	else entryPtrIndex=NULL;


	if (entryPtrIndex)
	{
		kkIndex=Tcl_GetHashValue(entryPtrIndex);
		Bdftable=kkIndex->Bdftable;
		for(entryPtr=Tcl_FirstHashEntry(Bdftable,&search);entryPtr !=NULL; entryPtr=Tcl_NextHashEntry(&search))
		{
			if (entryPtr)
			{
				kk=Tcl_GetHashValue(entryPtr);
				ckfree(kk->bitmap);
				ckfree((char *)kk);
				Tcl_DeleteHashEntry(entryPtr);
			}
		}
		Tcl_DeleteHashEntry(entryPtrIndex);
		Tcl_DeleteHashTable(Bdftable);
		ckfree((char *)kkIndex);

		x=strlen(Tcl_GetVar(interp,"FONT_LIST",TCL_GLOBAL_ONLY));
		if (Tcl_GetVar(interp,"FONT_LIST",TCL_GLOBAL_ONLY)) 
		{
			aux=(char *)ckalloc(strlen(Tcl_GetVar(interp,"FONT_LIST",TCL_GLOBAL_ONLY))+1);
			item=(char *)ckalloc(strlen(Tcl_GetVar(interp,"FONT_LIST",TCL_GLOBAL_ONLY))+1);
			strcpy(aux,Tcl_GetVar(interp,"FONT_LIST",TCL_GLOBAL_ONLY));
		Tcl_UnsetVar(interp,"FONT_LIST",TCL_GLOBAL_ONLY);
		primero=0;
			strcpy(item,aux);
		x=0;
		while(item)
		{
			if(strncmp(item,argv[1],strlen(argv[1]))!=0)
			{
	Tcl_SetVar(interp,"FONT_LIST",item,TCL_GLOBAL_ONLY|TCL_LIST_ELEMENT|TCL_APPEND_VALUE);
			primero++;
			}
		if (x) 	item=strtok(NULL," ");
			else {
				ckfree(item);
				item=strtok(aux," ");
				}
		x++;
		}

		ckfree(aux);
		Tcl_UnsetVar2(interp,"MISFONTS",argv[1],TCL_GLOBAL_ONLY);
		return TCL_OK;
		}
	}
	else 
	{
           Tcl_AppendResult(interp,"font: ",argv[1],"  doesn't exist in memory",
			(char *) NULL);
		return TCL_ERROR;
	}
 
}



int

Tk_ListFontCmd(dummy, interp, argc, argv)
    ClientData dummy;			/* Not used. */
    Tcl_Interp *interp;			/* Current interpreter. */
    int argc;				/* Number of arguments. */
    char **argv;			/* Argument strings. */
{

        FILE *id;
        int cond=1;
        unsigned char cadena[100],dir[200];

        strcpy(dir,Tcl_GetVar(interp,"tk_library",TCL_GLOBAL_ONLY));
        strcat(dir,"/fonts/idfont.bdf");

	if (argc>1){
                    Tcl_AppendResult(interp, "bad number of arguments, ",
			 "listfont \"", (char *) NULL);
		return TCL_ERROR;
	}

        id=fopen(dir,"r");
	if (!id) {
                    Tcl_AppendResult(interp, "Error when open idfont.bdf ",
			 " \"", (char *) NULL);
		return TCL_ERROR;
	}

        fgets(cadena,100,id);
        while(((char)*cadena!='\377')&&(cond)&&(strncmp(cadena,"ENDINDEX",8)!=0))
        {
		cadena[strlen(cadena)-1]='\0';
                Tcl_AppendResult(interp,cadena," ", (char *) NULL);
                fgets(cadena,30,id);
                fgets(cadena,100,id);
        }
        if (strncmp(cadena,"ENDINDEX",8)!=0 )
	{
        	Tcl_AppendResult(interp, "bad number of arguments, ",
			 "listfont \"", (char *) NULL);
             return TCL_ERROR;
	}
        return TCL_OK;
}



